/**********************************************************
　　製作者　　アドウィン
　　解　説　　SWでのサーボモータ制御 – プログラム例
**********************************************************/
#include <Arduino.h> // Arduino.h の読み込み
#include "switch.h"  // switch.h の読み込み

// サーボモータ用ピンの設定
int servo = 4;
// サーボのパルス幅
int t_us = 1500;

/*
 * setup 関数
 */
void setup() {
  /* ここにプログラムの最初に1回だけ実行したい処理を上から順に記述していきます */

  // シリアル通信を115200bpsで開始
  Serial.begin(115200);

  Serial.println("初期設定の開始");

  // スイッチの初期設定
  initSwitch();

  // サーボモータ用ピンの初期設定
  pinMode(servo, OUTPUT);
  digitalWrite(servo, LOW);

  Serial.println("初期設定の完了");
}

/*
 * loop 関数
 */
void loop() {
  /* ここにプログラム中で繰り返し実行したい処理を上から順に記述していきます */

  // パルス幅を変化
  if (SW1_ON && SW2_ON) {
    t_us = 1500;
  } else if (SW1_ON) {
    t_us += 10;
  } else if (SW2_ON) {
    t_us -= 10;
  }

  // Hの時間が0.9〜2.1msの範囲になるよう補正
  if (t_us < 900) {
    t_us = 900;
  } else if (t_us > 2100) {
    t_us = 2100;
  }

  // サーボモータにパルスを送る
  digitalWrite(servo, HIGH);
  delayMicroseconds(t_us);
  digitalWrite(servo, LOW);
  delay(15);
}