/**********************************************************
　　製作者　　アドウィン
　　解　説　　ロータリエンコーダのクリック検出 – プログラム例
**********************************************************/
#include <Arduino.h>      // Arduino.h の読み込み
#include "char8x8.h"      // char8x8.h の読み込み
#include "dotmatrixled.h" // dotmatrixled.h の読み込み

// ロータリエンコーダ用のピン
int encAPin = 26;
int encBPin = 27;
// クリック数
int click = 0;

/*
 * setup 関数
 */
void setup() {
  /* ここにプログラムの最初に1回だけ実行したい処理を上から順に記述していきます */

  // シリアル通信を115200bpsで開始
  Serial.begin(115200);

  Serial.println("初期設定の開始");

  // ドットマトリクスLED初期設定
  initLed();

  // ロータリエンコーダ用ピンの初期設定
  pinMode(encAPin, INPUT_PULLUP);
  pinMode(encBPin, INPUT_PULLUP);

  Serial.println("初期設定の完了");
}

/*
 * loop 関数
 */
void loop() {
  /* ここにプログラム中で繰り返し実行したい処理を上から順に記述していきます */

  // シリアルモニタに出力
  Serial.printf("φA: %d, φB %d, click: %d\n",
  digitalRead(encAPin), digitalRead(encBPin), click);
  
  // ドットマトリクスLEDのclick行目を点灯
  setLed(0xFF, ledCathodePattern[click]);

  // φAが立下がると
  if (LOW == digitalRead(encAPin)) {

    // チャタリング対策
    delay(1);
    // φAが立上がるまでループ
    while (LOW == digitalRead(encAPin)) delay(1);
    // チャタリング対策
    delay(1);

    // 点灯行を下げる
    click++;
    // 点灯行が7を超えた時、0に戻す
    if (click > 7)
      click = 0;
  }

  delay(1); // 時間待ち
}