/**********************************************************
　　製作者　　アドウィン
　　解　説　　矩形波でのスピーカ出力 – プログラム例
**********************************************************/
#include <Arduino.h> // Arduino.h の読み込み
#include "switch.h"  // switch.h の読み込み

// スピーカ用ピンの設定
int speaker = 18;
// 各音階での H と L の時間を配列化（ド・レ・ミ・ファ・ソ・ラ・シ・ド）
int onkai[8] = {1911, 1702, 1516, 1431, 1270, 1136, 1026, 955};
int iOnkai = 0; // 配列に使う添え字の変数

/*
 * setup 関数
 */
void setup() {
  /* ここにプログラムの最初に1回だけ実行したい処理を上から順に記述していきます */

  // シリアル通信を115200bpsで開始
  Serial.begin(115200);

  Serial.println("初期設定の開始");

  // スイッチの初期設定
  initSwitch();

  // スピーカ用ピンの初期設定
  pinMode(speaker, OUTPUT);
  digitalWrite(speaker, LOW);

  Serial.println("初期設定の完了");
}

/*
 * loop 関数
 */
void loop() {
  /* ここにプログラム中で繰り返し実行したい処理を上から順に記述していきます */

  // SW1が押された時
  if (SW1_ON) {
    // スピーカ用ピンをHレベルに
    digitalWrite(speaker, HIGH);
    // 時間待ち
    delayMicroseconds(onkai[iOnkai]);
    // スピーカ用ピンをLレベルに
    digitalWrite(speaker, LOW);
    // 時間待ち
    delayMicroseconds(onkai[iOnkai]);
  }

  // SW2が押された時
  if (SW2_ON) {

    // チャタリング対策
    delay(10);
    while (SW2_ON) delay(1);
    delay(10);

    // 音階をひとつ上げる
    iOnkai++;
    // 音階が7以上になった時、0に戻る
    if (iOnkai > 7)
      iOnkai = 0;
  }
}